/*================================================================================================*
 *     
 *================================================================================================*/

#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include "ltr\\include\\ltrapidefine.h"
#include "ltr\\include\\ltrapi.h"

/*================================================================================================*/
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
static void oem_printf
    (
    const char *Format,
    ...
    )
    {
    char str[2048];

    va_list va;
    va_start(va, Format);
    vsnprintf(str, sizeof(str) - 1, Format, va);
    va_end(va);
    str[sizeof(str) - 1] = '\0';
    CharToOemBuff(str, str, strlen(str));
    printf(str);
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
static void Abort
    (
    const char *Format,
    ...
    )
    {
    char str[1024];

    va_list va;
    va_start(va, Format);
    vsnprintf(str, sizeof(str) - 1, Format, va);
    va_end(va);
    str[sizeof(str) - 1] = '\0';
    CharToOemBuff(str, str, strlen(str));
    puts(str);
    exit(1);
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
int main(int argc, char *argv[])
    {
    TLTR ltr;
    int ltr_result;
    TCRATE_INFO ci;
    TLTR_CONFIG conf;

    oem_printf("*     *\n");
    if ((ltr_result = LTR_Init(&ltr)) != LTR_OK)
        Abort("    LTR: %s", LTR_GetErrorString(ltr_result));

    /*      */
    oem_printf("\n  ...");
    ltr.cc = CC_CONTROL;
    if ((ltr_result = LTR_Open(&ltr)) != LTR_OK)
        {
        Abort(" : %s", LTR_GetErrorString(ltr_result));
        }

    /*     */
    oem_printf("\n : %s\n", ltr.csn);
    ZeroMemory(&ci, sizeof(ci));
    if ((ltr_result = LTR_GetCrateInfo(&ltr, &ci)) != LTR_OK)
        Abort("     : %s", LTR_GetErrorString(ltr_result));

    oem_printf(" : ");
    switch (ci.CrateType)
        {
        case CRATE_TYPE_LTR010:  oem_printf("LTR010"); break;
        case CRATE_TYPE_LTR021:  oem_printf("LTR021"); break;
        case CRATE_TYPE_LTR030:  oem_printf("LTR030"); break;
        case CRATE_TYPE_LTR031:  oem_printf("LTR031"); break;
        default:                 oem_printf("???");    break;
        }
    oem_printf("\n: ");
    switch (ci.CrateInterface)
        {
        case CRATE_IFACE_USB:    oem_printf("USB");    break;
        case CRATE_IFACE_TCPIP:  oem_printf("TCP/IP"); break;
        default:                 oem_printf("???");    break;
        }
    
    oem_printf("\n  ...");
    conf.userio[0] = LTR_USERIO_DEFAULT;
    conf.userio[1] = LTR_USERIO_DEFAULT;
    conf.userio[2] = LTR_USERIO_DEFAULT;
    conf.digout_en = TRUE;
    conf.digout[0] = LTR_DIGOUT_CONST0;
    conf.digout[1] = LTR_DIGOUT_CONST0;
    if ((ltr_result = LTR_Config(&ltr, &conf)) != LTR_OK)
        {
        LTR_Close(&ltr);
        Abort(" : %s", LTR_GetErrorString(ltr_result));
        }

    oem_printf("\n  ...");
    if ((ltr_result = LTR_StartSecondMark(&ltr, LTR_MARK_INTERNAL)) != LTR_OK)
        {
        LTR_Close(&ltr);
        Abort(" : %s", LTR_GetErrorString(ltr_result));
        }

    oem_printf("\n  ,    \n");
    getch();

    oem_printf("\n  ...");
    if ((ltr_result = LTR_StopSecondMark(&ltr)) != LTR_OK)
        {
        LTR_Close(&ltr);
        Abort(" : %s", LTR_GetErrorString(ltr_result));
        }

    LTR_Close(&ltr);
    oem_printf("\n \n");

    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
